VERSION 5.00
Begin VB.UserControl Button 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H004A3C31&
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   855
   ScaleHeight     =   19
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   57
   Begin VB.Label lblCaption 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "<caption>"
      BeginProperty Font 
         Name            =   "BankGothic Lt BT"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   240
      Left            =   270
      TabIndex        =   0
      Top             =   30
      Width           =   2295
   End
End
Attribute VB_Name = "Button"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'
'   How to use this button:
'
'   ButtonStyle: the graphic used to draw the button, in the button_gfx.bmp file.
'
'   0  - minimize
'   1  - restore down
'   2  - maximize
'   3  - close
'   4  - check box
'   6  - option box
'   8  - menu
'   9  - help
'   10 - browse
'   11 - play
'   12 - pause
'
'   Toggle: the way the button handles being clicked by the user
'
'   0 - normal
'   1 - check box
'   2 - option box
'
'   Value: on/off, used by check box or option box
'

'Event Declarations:
Event Click() 'MappingInfo=userControl,userControl,-1,Click

'Default Property Values:
Const m_def_Toggle = 0
Const m_def_ButtonStyle = 0
Const m_def_Value = 0
'Property Variables:
Dim m_Toggle As Byte
Dim m_ButtonStyle As Byte
Dim m_Value As Byte

Const BUTTON_WIDTH As Byte = 16
Const BUTTON_HEIGHT As Byte = 16
Const BUTTON_UP = 0
Const BUTTON_MOVE = 1
Const BUTTON_DOWN = 2

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=userControl,userControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Private Sub lblCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseMove 1, 0, 0, 0
End Sub

Private Sub userControl_Click()
    'stuff
End Sub

Private Sub userControl_DblClick()

    UserControl_MouseDown 1, 0, 0, 0

End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    BitBlt UserControl.hdc, 0, 0, BUTTON_WIDTH, BUTTON_HEIGHT, buttonGfxDC, BUTTON_WIDTH * BUTTON_DOWN, m_ButtonStyle * 16 + m_Value * BUTTON_HEIGHT, vbSrcCopy
    UserControl.Refresh

End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If (X < 0) Or (X > UserControl.ScaleWidth) Or (Y < 0) Or (Y > UserControl.ScaleHeight) Then  'the MOUSELEAVE pseudo-event
        ReleaseCapture
        BitBlt UserControl.hdc, 0, 0, BUTTON_WIDTH, BUTTON_HEIGHT, buttonGfxDC, BUTTON_WIDTH * BUTTON_UP, m_ButtonStyle * 16 + m_Value * BUTTON_HEIGHT, vbSrcCopy
        UserControl.Refresh
    ElseIf GetCapture() <> UserControl.hWnd Then 'the MOUSEENTER pseudo-event
        SetCapture UserControl.hWnd
        BitBlt UserControl.hdc, 0, 0, BUTTON_WIDTH, BUTTON_HEIGHT, buttonGfxDC, BUTTON_WIDTH * BUTTON_MOVE, m_ButtonStyle * 16 + m_Value * BUTTON_HEIGHT, vbSrcCopy
        UserControl.Refresh
    End If

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent Click
    
    If Toggle = 1 Then
        If m_Value = 0 Then
            m_Value = 1
        Else
            m_Value = 0
        End If
    ElseIf Toggle = 2 Then
        m_Value = 1
    End If
    
End Sub

Public Sub RefreshButton()

    BitBlt UserControl.hdc, 0, 0, BUTTON_WIDTH, BUTTON_HEIGHT, buttonGfxDC, BUTTON_WIDTH * BUTTON_UP, m_ButtonStyle * 16 + m_Value * BUTTON_HEIGHT, vbSrcCopy
    UserControl.Refresh
    
End Sub

'Load property values from storage
Private Sub userControl_ReadProperties(PropBag As PropertyBag)

    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H0&)
    lblCaption.Caption = PropBag.ReadProperty("Caption", "<caption>")
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    m_Toggle = PropBag.ReadProperty("Toggle", m_def_Toggle)
    m_ButtonStyle = PropBag.ReadProperty("ButtonStyle", m_def_ButtonStyle)

End Sub

'Write property values to storage
Private Sub userControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H0&)
    Call PropBag.WriteProperty("Caption", lblCaption.Caption, "<caption>")
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("Toggle", m_Toggle, m_def_Toggle)
    Call PropBag.WriteProperty("ButtonStyle", m_ButtonStyle, m_def_ButtonStyle)

End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=userControl,userControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'Initialize Properties for User Control
Private Sub userControl_InitProperties()
    m_Value = m_def_Value
    m_Toggle = m_def_Toggle
    m_ButtonStyle = m_def_ButtonStyle
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblCaption,lblCaption,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = lblCaption.Font
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblCaption,lblCaption,-1,Caption
Public Property Get Caption() As String
    Caption = lblCaption.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    lblCaption.Caption() = New_Caption
    PropertyChanged "Caption"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Value() As Byte
    Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Byte)
    If New_Value >= 1 Then
        New_Value = 1
    Else
        New_Value = 0
    End If
    m_Value = New_Value
    PropertyChanged "Value"
    BitBlt UserControl.hdc, 0, 0, BUTTON_WIDTH, BUTTON_HEIGHT, buttonGfxDC, BUTTON_WIDTH * BUTTON_UP, m_ButtonStyle * 16 + m_Value * BUTTON_HEIGHT, vbSrcCopy
    UserControl.Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,1,0,0
Public Property Get Toggle() As Byte
Attribute Toggle.VB_Description = "0 - none; 1 - check; 2 - option"
    Toggle = m_Toggle
End Property

Public Property Let Toggle(ByVal New_Toggle As Byte)
    If Ambient.UserMode Then Err.Raise 382
    m_Toggle = New_Toggle
    PropertyChanged "Toggle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get ButtonStyle() As Byte
    ButtonStyle = m_ButtonStyle
End Property

Public Property Let ButtonStyle(ByVal New_ButtonStyle As Byte)
    m_ButtonStyle = New_ButtonStyle
    PropertyChanged "ButtonStyle"
End Property
