Attribute VB_Name = "modGostek"
Option Explicit

Public Const BUTTON_WIDTH = 64
Public Const BUTTON_HEIGHT = 24

Public Const MENU_WIDTH = 64
Public Const MENU_HEIGHT = 16

Public Const BUTTON_SMALL = 0
Public Const BUTTON_LARGE = 1
Public Const BUTTON_MENU = 2
Public Const BUTTON_TOOL = 3

Public Const BUTTON_X = 48
Public Const BUTTON_Y = 0

Public Const MENU_X = 48
Public Const MENU_Y = 96

Public Const BUTTON_UP = 0
Public Const BUTTON_MOVE = 1
Public Const BUTTON_DOWN = 2

Global buttonGfxDC As Long

'bitblt
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
        ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
        
'stretchblt
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
        ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, _
        ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, _
        ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long


'mouse over
Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetCapture Lib "user32" () As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long

'dragging window
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
        (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Const WM_NCLBUTTONDOWN = &HA1

'ini file
Private Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" _
        (ByVal sSectionName As String, ByVal sKeyName As String, _
        ByVal lDefault As Long, ByVal sFileName As String) As Long

Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" _
        (ByVal sSectionName As String, ByVal sReturnedString As String, _
        ByVal lSize As Long, ByVal sFileName As String) As Long

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
        (ByVal sSectionName As String, ByVal sKeyName As String, ByVal sDefault As String, _
        ByVal sReturnedString As String, ByVal lSize As Long, ByVal sFileName As String) As Long

Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" _
        (ByVal sSectionName As String, ByVal sString As String, ByVal sFileName As String) As Long

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
        (ByVal sSectionName As String, ByVal sKeyName As String, _
        ByVal sString As String, ByVal sFileName As String) As Long
        
'browse
Private Type BROWSEINFO
    hOwner            As Long
    pidlRoot          As Long
    pszDisplayName    As String
    lpszTitle         As String
    ulFlags           As Long
    lpfn              As Long
    lParam            As Long
    iImage            As Long
End Type

Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000
Private Const MAX_PATH = 260

Private Declare Function SHGetPathFromIDList Lib "shell32" Alias "SHGetPathFromIDListA" _
        (ByVal pidl As Long, ByVal pszPath As String) As Long

Private Declare Function SHBrowseForFolder Lib "shell32" Alias "SHBrowseForFolderA" _
        (lpBrowseInfo As BROWSEINFO) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal pv As Long)

'save a section to an INI file
Public Sub saveSection(sectionName As String, sectionData As String, Optional fileName As String)

    Dim lReturn  As Long
    
    If fileName = "" Then
        fileName = App.path & "\gostek.ini"
    End If
    
    lReturn = WritePrivateProfileSection(sectionName, sectionData, fileName)

End Sub

'load a string from an INI file
Public Function loadString(section As String, Entry As String, Optional fileName As String, Optional length As Integer) As String
    
    Dim sString  As String
    Dim lSize    As Long
    Dim lReturn  As Long
    
    If fileName = "" Then
        fileName = App.path & "\soldat.ini"
    End If
    
    If length = 0 Then length = 10

    sString = String$(length, "*")
    lSize = Len(sString)
    lReturn = GetPrivateProfileString(section, Entry, "", sString, lSize, fileName)
    
    loadString = Left(sString, lReturn)

End Function

'load an integer from an INI file
Public Function loadInt(section As String, Entry As String, Optional fileName As String) As Long
    
    Dim lReturn As Long
    
    If fileName = "" Then
        fileName = App.path & "\polyworks.ini"
    End If
    
    lReturn = GetPrivateProfileInt(section, Entry, -1, fileName)
    
    loadInt = lReturn

End Function

Public Function RGBtoHex(decValue As Long) As String

    Dim hexValue As String

    hexValue = Hex$(Val(decValue))

    If Len(hexValue) < 6 Then
        hexValue = String$(6 - Len(hexValue), "0") + hexValue
    End If
    
    RGBtoHex = hexValue

End Function

Public Function ClrToHex(r As Byte, g As Byte, b As Byte) As String

    Dim hexValue As String
    Dim decValue As Long
    
    decValue = RGB(r, g, b)
    hexValue = Hex$(Val(decValue))
    
    If Len(hexValue) < 6 Then
        hexValue = String$(6 - Len(hexValue), "0") + hexValue
    End If
    
    ClrToHex = hexValue

End Function

Public Function HexToLong(hexValue As String) As Long

    On Error GoTo ErrorHandler

    If Len(hexValue) > 8 Then
        hexValue = Right$(hexValue, 8)
    End If

    HexToLong = CLng("&H" & hexValue)

    Exit Function
    
ErrorHandler:

    HexToLong = -1

End Function

'browse
Public Function SelectFolder(ownerForm As Form) As String

    Dim bi As BROWSEINFO
    Dim pidl As Long
    Dim path As String
    Dim pos As Long
    
    With bi
        .hOwner = ownerForm.hWnd
        .pidlRoot = 0&
        .lpszTitle = "Select Soldat folder"
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With
    
    pidl = SHBrowseForFolder(bi)
    path = Space$(MAX_PATH)
    
    If SHGetPathFromIDList(ByVal pidl, ByVal path) Then
        pos = InStr(path, Chr$(0))
        SelectFolder = LCase$(Left(path, pos - 1))
    End If
    
    Call CoTaskMemFree(pidl)
    
End Function
